class Cafe:
    """"permet de definir un probleme"""

    def actions(self):
        """retourne la liste d'actions"""
        return([])

    def etats(self):
        """retourne la liste d'etats"""
        return([])

    def transition(self,s,a):
        """definit les consequence d une action"""
        return(s)


    def recompense(self,s,a,sarr):
        """definit la recompense obtenue"""
        return(0)



class SystemeExecute:
    """ permet d'executer une politique """

    def __init__(self,pb):
        """intialise avec un probleme"""
        self.pb=pb

    def executerPi(self,pi,depart,nb):
        """execute une politique"""
        s=depart
        for i in range(nb):
            action=pi[s]
            sFin=pb.transition(s,action)
            print(s," -> ",action," : ",sFin)
            s=sFin

    def executerPiRec(self,pi,depart,nb):
        """execute une politique avec recompenses"""
        s=depart
        gamma=0.99
        somme=0
        for i in range(nb):
            action=pi[s]
            sFin=pb.transition(s,action)
            r=pb.recompense(s,action,sFin)
            somme=somme+(gamma**i)*r
            print(s," -> ",action," : ",sFin,"<",r,">")
            s=sFin
        return somme



#************************************************************
pb=Cafe()


# ecrire une politique
# pi={}

print ("*** politique ***")
print(pi)

print("*** test execution ***")
systemExec = SystemeExecute(pb)
systemExec.executerPi(pi,(1,0),10)

print("*** test execution recompense ***")
systemExec = SystemeExecute(pb)
somme=systemExec.executerPiRec(pi,(1,0),10)
print("somme: ",somme)
